#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# Copyright 2008 (C) Raster Software Vigo (Sergio Costas)

# This file is part of EasyWall
#
# EasyWall is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# EasyWall is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# append the directories where we install the devede's own modules

import sys
import locale
import gettext
import os
import sys

def print_usage():
	
	print "Usage: easywall [rebuild/start/stop]"
	print
	sys.exit(1)

# Check where are the files (current directory, /usr/local, or /usr)

type=-1
try:
	fichero=open("./easywall_core.py","r")
	fichero.close()
	type=2
except:
	pass

if type==-1:
	try:
		fichero=open("/usr/local/lib/easywall/easywall_core.py","r")
		fichero.close()
		type=1
	except:
		pass

if type==-1:
	try:
		fichero=open("/usr/lib/easywall/easywall_core.py","r")
		fichero.close()
		type=0
	except:
		pass

if type==0:
	share_locale="/usr/share/locale"
	share_path="/usr/share"
	sys.path.append("/usr/lib/easywall")
	help_path="/usr/share/doc/easywall"
	print "Using package-installed files"
	
elif type==1:
	share_locale="/usr/share/locale"
	share_path="/usr/local/share"
	sys.path.append("/usr/local/lib/easywall")
	help_path="/usr/local/share/doc/easywall"
	print "Using local-installed files"
	
elif type==2:
	share_locale="./po/"
	share_path="."
	sys.path.append(os.getcwd())
	help_path=os.path.join(os.getcwd(),"doc")
	print "Using direct files"

else:
	print "Can't locate extra files. Aborting."
	sys.exit(1)

widget_library=None

if len(sys.argv)!=1:
	
	import easywall_core
	
	gettext.bindtextdomain('easywall',share_locale)
	locale.setlocale(locale.LC_ALL,"")
	gettext.textdomain('easywall')
	gettext.install("easywall",localedir=share_locale) # None is sys default locale
	
	if len(sys.argv)!=2:
		print_usage()
		
	ewall=easywall_core.easywall_core(locale.getdefaultlocale()[0])
	if sys.argv[1]=="rebuild":
		ewall.create_firewall()
		retval=ewall.set_firewall_status("restart")
		if (retval!=0) and (retval!=None):
			print _("Failed to restart the firewall.\nCheck that the templates are correct.")
			print ewall.get_output()
			w=None
			ewall.set_firewall_status("stop")
			sys.exit(1)
				
		sys.exit(0)
	elif sys.argv[1]=="start":
		retval=ewall.set_firewall_status("start")
		
		if (retval!=0) and (retval!=None):
			print _("Failed to start the firewall.\nCheck that the templates are correct.")
			print ewall.get_output()
			ewall.set_firewall_status("stop")
			sys.exit(1)
		sys.exit(0)
	elif sys.argv[1]=="stop":
		retval=ewall.set_firewall_status("stop")
		
		if (retval!=0) and (retval!=None):
			print _("Failed to stop the firewall.\nCheck that the templates are correct.")
			print ewall.get_output()
			sys.exit(1)
		sys.exit(0)
	else:
		print_usage()
		sys.exit(1)

try:
	import easywall_gtk
	wcode=easywall_gtk.easywall_gtk(share_path,share_locale,help_path)
except:
	
	# A QT port should put here the code to initialize the window, creating an object
	# called wcode with, at least, two methods: SET_LOCALE() and SHOW_MAIN().
	
	print "Can't load EasyWall_gtk"
	sys.exit(1)
	

#####################
#   GetText Stuff   #
#####################

gettext.bindtextdomain('easywall',share_locale)
locale.setlocale(locale.LC_ALL,"")
gettext.textdomain('easywall')
gettext.install("easywall",localedir=share_locale) # None is sys default locale

wcode.set_locale()

_ = gettext.gettext

wcode.show_main()

